// START A3HEADER
//
// The Atlantis program, and all of it's source code (including
// this file) is Copyright (c) 1995-1998 by Geoff Dunbar. This
// source code is distributed under the terms of the license
// agreement in the file LICENSE.txt. If this file was not included
// with the source code you received, you may not use, modify, or
// distribute this source code.
//
// See the Atlantis Project web page for details:
// http://www.prankster.com/project
//
// END A3HEADER
#include "alist.h"

AListElem::~AListElem() {
}

AList::AList() {
  list = 0;
  lastelem = 0;
  num = 0;
}

AList::~AList() {
  DeleteAll();
}

void AList::DeleteAll() {
  AListElem * temp;
  while (list) {
    temp = list->next;
    delete list;
    list = temp;
  }
  lastelem = 0;
  num = 0;
}

void AList::Empty() {
  AListElem * temp;
  while (list) {
    temp = list->next;
    list->next = 0;
    list = temp;
  }
  lastelem = 0;
  num = 0;
}

void AList::Insert(AListElem * e) {
  num ++;
  e->next = list;
  list = e;
  if (!lastelem) lastelem = list;
}

void AList::Add(AListElem * e) {
  num ++;
  if (list) {
    lastelem->next = e;
    e->next = 0;
    lastelem = e;
  } else {
    list = e;
    e->next = 0;
    lastelem = list;
  }
}

AListElem * AList::Next(AListElem * e) {
  if (!e) return 0;
  return e->next;
}

AListElem * AList::First() {
  return list;
}

AListElem * AList::Get(AListElem * e) {
  AListElem * temp = list;
  while (temp) {
    if (temp == e) return temp;
    temp = temp->next;
  }
  return 0;
}

char AList::Remove(AListElem * e) {
  AListElem * temp = list;
  if (!e) return 0;
  if (!list) return 0;
  if (list==e) {
    list=list->next;
    num--;
    if (lastelem == e) lastelem = 0;
    return 1;
  }
  
  AListElem * p = list;
  temp = list->next;
  while (temp) {
    if (temp==e) {
      p->next = temp->next;
      num--;
      if (p->next == 0) lastelem = p;
      return 1;
    }
    p=temp;
    temp=temp->next;
  }
  return 0;
}
		
int AList::Num() {
  return num;
}
