// START A3HEADER
//
// The Atlantis program, and all of it's source code (including
// this file) is Copyright (c) 1995-1998 by Geoff Dunbar. This
// source code is distributed under the terms of the license
// agreement in the file LICENSE.txt. If this file was not included
// with the source code you received, you may not use, modify, or
// distribute this source code.
//
// See the Atlantis Project web page for details:
// http://www.prankster.com/project
//
// END A3HEADER
#ifndef ALIST_CLASS
#define ALIST_CLASS

class AListElem;
class AList;

class AListElem {
public:
  virtual ~AListElem();
  
  AListElem * next;
};

class AList {
public:
  AList();
  ~AList();
  void DeleteAll();
  void Empty(); /* Clears the list without deleting members */
  
  AListElem * Get(AListElem *);
  char Remove(AListElem *);
  void Insert(AListElem *); /* into the front */
  void Add(AListElem *); /* to the back */
  AListElem * Next(AListElem *);
  AListElem * First();
  int Num();
private:
  AListElem *list;
  AListElem *lastelem;
  int num;
};

#define forlist(l)	AListElem * elem, * _elem2; \
      for ( elem=(l)->First(), \
      _elem2 = (elem ? (l)->Next(elem) : 0); \
      elem; \
      elem = _elem2, \
      _elem2 = (_elem2 ? ((l)->Next(_elem2)) : 0))

#endif
