// START A3HEADER
//
// The Atlantis program, and all of it's source code (including
// this file) is Copyright (c) 1995-1998 by Geoff Dunbar. This
// source code is distributed under the terms of the license
// agreement in the file LICENSE.txt. If this file was not included
// with the source code you received, you may not use, modify, or
// distribute this source code.
//
// See the Atlantis Project web page for details:
// http://www.prankster.com/project
//
// END A3HEADER
#ifndef ASTRING_CLASS
#define ASTRING_CLASS

#include <iostream.h>
#include "alist.h"

class AString : public AListElem {
    friend ostream & operator <<(ostream &os, const AString &);
    friend istream & operator >>(istream &is, AString &);
public:

    AString();
    AString(char *);
    AString(int);
    AString(char);
    AString(const AString &);
    ~AString();
  
    int operator==(const AString &);
    int operator==(char *);
    int operator==(const char *);
    int CheckPrefix(const AString &);
    AString operator+(const AString &);
    AString & operator+=(const AString &);
  
    AString & operator=(const AString &);
    AString & operator=(const char *);
    
    char *Str();
    int Len();
  
    AString *gettoken();
    int getat();
    AString *getlegal();
    AString *Trunc(int);
    int value();
    AString *StripWhite();

private:
    
    int len;
    char * str;
    int isEqual(const char *);
};

#endif
