// START A3HEADER
//
// The Atlantis program, and all of it's source code (including
// this file) is Copyright (c) 1995-1998 by Geoff Dunbar. This
// source code is distributed under the terms of the license
// agreement in the file LICENSE.txt. If this file was not included
// with the source code you received, you may not use, modify, or
// distribute this source code.
//
// See the Atlantis Project web page for details:
// http://www.prankster.com/project
//
// END A3HEADER
#ifndef BATTLE_CLASS
#define BATTLE_CLASS

class Battle;

#include "astring.h"
#include "alist.h"
#include "fileio.h"
#include "army.h"
#include "items.h"

enum {
  ASS_NONE,
  ASS_SUCC,
  ASS_FAIL
};

class BattlePtr : public AListElem {
public:
  Battle * ptr;
};

class Battle : public AListElem
{
public:
    Battle();
    ~Battle();
    
    void Report(Areport *,Faction *);
    void AddLine(const AString &);
	
    void Run( ARegion *,
              Unit *,
              AList *,
              Unit *,
              AList *,
              int ass,
              ARegionList *pRegs );
    void FreeRound(Army *,Army *);
    void NormalRound(int,Army *,Army *);
    void DoAttack( int round, 
                   Soldier *a,
                   Army *attackers,
                   Army *def, 
                   int behind );

    void DoAttack(int,Soldier *,Army *,int);
    void GetSpoils(AList *,ItemList *);

    //
    // These functions should be implemented in specials.cpp
    //
    void UpdateShields(Army *);
    void DoSpecialAttack( int round,
                          Soldier *a,
                          Army *attackers,
                          Army *def, 
                          int behind );

    void WriteSides(ARegion *,Unit *,Unit *,AList *,AList *,int,
                    ARegionList *pRegs );
    int assassination;
    Faction * attacker; /* Only matters in the case of an assassination */
    AString * asstext;
    AList text;
};

#endif
