// START A3HEADER
//
// The Atlantis program, and all of it's source code (including
// this file) is Copyright (c) 1995-1998 by Geoff Dunbar. This
// source code is distributed under the terms of the license
// agreement in the file LICENSE.txt. If this file was not included
// with the source code you received, you may not use, modify, or
// distribute this source code.
//
// See the Atlantis Project web page for details:
// http://www.prankster.com/project
//
// END A3HEADER
#ifndef HELPER
#define HELPER

//
// Version macros
//
typedef unsigned int ATL_VER;

#define MAKE_ATL_VER( x, y, z ) ( (( x ) << 0x10 ) + (( y ) << 0x8 ) + ( z ) )

#define ATL_VER_MAJOR( x ) ( ( ( x ) >> 0x10 ) % 0x100 )
#define ATL_VER_MINOR( x ) ( ( ( x ) >> 0x8 ) % 0x100 )
#define ATL_VER_PATCH( x ) ( ( x ) % 0x100 )

#define ATL_VER_STRING( x ) AString( AString( (int) ATL_VER_MAJOR( x ) ) + \
"." + AString( (int) ATL_VER_MINOR( x ) ) + "." + \
AString( (int) ATL_VER_PATCH( x ) ) ) + \
( ( ATL_VER_MINOR( x ) % 2 ) ? "" : " (beta)" )

//
// Some bitfield functions
//
typedef unsigned int BITFIELD;

#define BIT( x ) ( 1 << ( x ))
#define GET_BIT( b, x ) (( b & ( 1 << ( x ))) ? 1 : 0 )
#define SET_BIT( b, x ) ( b |= ( 1 << ( x )))
#define CLEAR_BIT( b, x ) ( b &= ~( 1 << ( x )))

//
// Convenient macros
//
#define SAFE_DELETE( x ) delete ( x ); x = 0;

#endif
