// START A3HEADER
//
// The Atlantis program, and all of it's source code (including
// this file) is Copyright (c) 1995-1998 by Geoff Dunbar. This
// source code is distributed under the terms of the license
// agreement in the file LICENSE.txt. If this file was not included
// with the source code you received, you may not use, modify, or
// distribute this source code.
//
// See the Atlantis Project web page for details:
// http://www.prankster.com/project
//
// END A3HEADER
#include "production.h"
#include "gameio.h"
#include "items.h"

Production::Production()
{
    itemtype = -1;
    amount = 0;
    baseamount = 0;
    level = 0;
    productivity = 0;
    skill = -1;
}

Production::Production(int it,int maxamt)
{
    itemtype = it;
    amount = maxamt;
    if( Globals->RANDOM_ECONOMY )
    {
        amount += getrandom(maxamt);
    }
    baseamount = amount;
    level = 1;
    productivity = 1;
    skill = ItemDefs[it].skill;
}

void Production::Writeout(Aoutfile * f)
{
    f->PutInt(itemtype);
    f->PutInt(amount);
    f->PutInt(baseamount);
    f->PutInt(skill);
    f->PutInt(level);
    f->PutInt(productivity);
}

void Production::Readin(Ainfile * f)
{
    itemtype = f->GetInt();
    amount = f->GetInt();
    baseamount = f->GetInt();
    skill = f->GetInt();
    level = f->GetInt();
    productivity = f->GetInt();
}

AString Production::WriteReport()
{
    AString temp = ItemString(itemtype,amount);
    return temp;
}

void ProductionList::Writeout(Aoutfile * f)
{
    f->PutInt(Num());
    forlist(this) {
        ((Production *) elem)->Writeout(f);
    }
}

void ProductionList::Readin(Ainfile * f)
{
    int n = f->GetInt();
    for (int i=0; i<n; i++)
    {
        Production * p = new Production;
        p->Readin(f);
        Add(p);
    }
}
	
Production * ProductionList::GetProd(int t,int s)
{
    forlist(this) {
        Production * p = (Production *) elem;
        if (p->itemtype == t && p->skill == s) return p;
    }
    return 0;
}

void ProductionList::AddProd(Production * p)
{
    Production * p2 = GetProd(p->itemtype,p->skill);
    if (p2)
    {
        Remove(p2);
        delete p2;
    }
	
    Add(p);
}
