// START A3HEADER
//
// The Atlantis program, and all of it's source code (including
// this file) is Copyright (c) 1995-1998 by Geoff Dunbar. This
// source code is distributed under the terms of the license
// agreement in the file LICENSE.txt. If this file was not included
// with the source code you received, you may not use, modify, or
// distribute this source code.
//
// See the Atlantis Project web page for details:
// http://www.prankster.com/project
//
// END A3HEADER
#ifndef PRODUCTION_CLASS
#define PRODUCTION_CLASS

#include "gamedefs.h"
#include "alist.h"
#include "fileio.h"

#define P_BIG 40
#define P_SMALL 20

class Production : public AListElem {
public:
  Production(int,int); /* item type, amt max */
  Production();
  
  void Writeout(Aoutfile *);
  void Readin(Ainfile *);
  AString WriteReport();
  
  int itemtype;
  int baseamount;
  int amount;
  int skill;
  int level;
  int productivity;
  int activity;
};

class ProductionList : public AList {
public:
  Production * GetProd(int,int); /* item type, skill */
  void AddProd(Production *);
  
  void Writeout(Aoutfile *);
  void Readin(Ainfile *);
};

#endif
