// START A3HEADER
//
// The Atlantis program, and all of it's source code (including
// this file) is Copyright (c) 1995-1998 by Geoff Dunbar. This
// source code is distributed under the terms of the license
// agreement in the file LICENSE.txt. If this file was not included
// with the source code you received, you may not use, modify, or
// distribute this source code.
//
// See the Atlantis Project web page for details:
// http://www.prankster.com/project
//
// END A3HEADER
#ifdef GAME_SPELLS
//
// If GAME_SPELLS is defined, this is being included from inside the Game
// class in game.h
//

//
// Spell parsing
//
void ProcessCastGateLore(Unit *,AString *, OrdersCheck *pCheck );
void ProcessCastPortalLore(Unit *,AString *, OrdersCheck *pCheck );
void ProcessFarsight(Unit *,AString *, OrdersCheck *pCheck );
void ProcessTeleportation(Unit *,AString *, OrdersCheck *pCheck );
void ProcessGenericSpell(Unit *, int, OrdersCheck *pCheck );
void ProcessPhanBeasts(Unit *,AString *, OrdersCheck *pCheck );
void ProcessPhanUndead(Unit *,AString *, OrdersCheck *pCheck );
void ProcessPhanDemons(Unit *,AString *, OrdersCheck *pCheck );
void ProcessInvisibility(Unit *,AString *, OrdersCheck *pCheck );
void ProcessBirdLore(Unit *,AString *, OrdersCheck *pCheck );
void ProcessCastRegion(Unit *,int,AString *,AString &, OrdersCheck *pCheck );
void ProcessMindReading(Unit *,AString *, OrdersCheck *pCheck );

//
// Spell running
//
void RunDetectGates(ARegion *,Object *,Unit *);
void RunFarsight(ARegion *,Unit *);
void RunGateJump(ARegion *,Object *,Unit *);
void RunTeleport(ARegion *,Object *,Unit *);
void RunPortalLore(ARegion *,Object *,Unit *);
void RunEarthLore(ARegion *,Unit *);
void RunClearSkies(ARegion *,Unit *);
void RunPhanBeasts(ARegion *,Unit *);
void RunPhanUndead(ARegion *,Unit *);
void RunPhanDemons(ARegion *,Unit *);
void RunInvisibility(ARegion *,Unit *);
void RunWolfLore(ARegion *,Unit *);
void RunBirdLore(ARegion *,Unit *);
void RunDragonLore(ARegion *,Unit *);
void RunSummonSkeletons(ARegion *,Unit *);
void RunRaiseUndead(ARegion *,Unit *);
void RunSummonLich(ARegion *,Unit *);
void RunSummonImps(ARegion *,Unit *);
void RunSummonDemon(ARegion *,Unit *);
void RunSummonBalrog(ARegion *,Unit *);
void RunCreateArtifact(ARegion *,Unit *,int,int,int,int);
void RunEngraveRunes(ARegion *,Object *,Unit *);
void RunConstructGate(ARegion *,Unit *);
void RunEnchantSwords(ARegion *,Unit *);
void RunEnchantArmor(ARegion *,Unit *);
void RunMindReading(ARegion *,Unit *);
#endif
